
#include <jni.h>
#include <stdio.h>
#include "Ex1.h"

jint Java_Ex1_sum_1int_1list(JNIEnv *env, jclass ex1, jobject iter) {
  int result = 0;
  
  jclass iterclass = (*env)->GetObjectClass(env,iter);
  jmethodID hasNext_mid, next_mid;

  hasNext_mid = (*env)->GetMethodID(env,iterclass,"hasNext","()Z");
  next_mid = (*env)->GetMethodID(env,iterclass,"next","()Ljava/lang/Object;");

  jclass Integerclass = (*env)->FindClass(env,"java/lang/Integer");
  jmethodID intValue = (*env)->GetMethodID(env,Integerclass,"intValue","()I");

  while((*env)->CallBooleanMethod(env,iter,hasNext_mid)) {
    jobject IntObj = (*env)->CallObjectMethod(env,iter,next_mid);
    int val = (*env)->CallIntMethod(env,IntObj,intValue);
    result += val;
  }

  return result;
}

