
open Printf

type t = 
  | Empty
  | Single of int
  | Double of int * int

external increment : t -> t = "increment_t"

let to_string = function
  | Empty -> "Empty"
  | Single i -> string_of_int i
  | Double(x,y) -> sprintf "(%d,%d)" x y 

let _ = 
  let x = Single 10 in
  let x' = increment x in
  let y = Double(3,4) in
  let y' = increment y in
  let z = Empty in
  let z' = increment z in
    Printf.printf "increment %s is %s\n" (to_string x) (to_string x');
    Printf.printf "increment %s is %s\n" (to_string y) (to_string y');
    Printf.printf "increment %s is %s\n" (to_string z) (to_string z');
    ()
